//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_STRING 128

typedef char String[MAX_STRING];

typedef struct nation_tag {
    String Name;
    struct nation_tag * Allie;
    struct nation_tag * Next;
} NationType;

typedef NationType * NATIONTYPE;
//-----------------------------------------------------------------------------
void * Malloc(int Size) {

    void * Memory;

    if ((Memory = malloc(Size)) == NULL) {
        perror("Cannot malloc");
        exit(EXIT_FAILURE);
    } else {
        return(Memory);
    }
}
//-----------------------------------------------------------------------------
void Free(void ** Memory) {

    free(*Memory);
    *Memory = NULL;
}
//-----------------------------------------------------------------------------
NATIONTYPE InputNations(NATIONTYPE Head) {

    String NationName;
    NATIONTYPE NewNation;

    do {
        printf("Enter nation name : ");
        fgets(NationName,MAX_STRING,stdin);
        NationName[strlen(NationName)-1] = '\0';
        if (strlen(NationName) > 0) {
            NewNation = (NATIONTYPE)Malloc(sizeof(NationType));
            strcpy(NewNation->Name,NationName);
            NewNation->Allie = NULL;
            NewNation->Next = Head;
            Head = NewNation;
        }
    } while (strlen(NationName) > 0);

    return(Head);
}
//-----------------------------------------------------------------------------
NATIONTYPE FindNation(NATIONTYPE Head,String Name) {

    while (Head != NULL && strcmp(Head->Name,Name)) {
        Head = Head->Next;
    }
    return(Head);
}
//-----------------------------------------------------------------------------
void LinkAllies(NATIONTYPE Head) {

    NATIONTYPE CurrentNation;
    String NationName;

    CurrentNation = Head;
    while (CurrentNation != NULL) {
        do {
            printf("Enter best ally name for %s : ",CurrentNation->Name);
            fgets(NationName,MAX_STRING,stdin);
            NationName[strlen(NationName)-1] = '\0';
            CurrentNation->Allie = FindNation(Head,NationName);
        } while (CurrentNation->Allie == NULL);
        CurrentNation = CurrentNation->Next;
    }
}
//-----------------------------------------------------------------------------
void PrintAllies(NATIONTYPE Head) {

    while (Head != NULL) {
        printf("The best ally of %s is %s\n",Head->Name,Head->Allie->Name);
        Head = Head->Next;
    }
}
//-----------------------------------------------------------------------------
void FreeNations(NATIONTYPE * Head) {

    if ((*Head)->Next != NULL) {
        FreeNations(&((*Head)->Next));
    }
    Free((void **) Head);
}
//-----------------------------------------------------------------------------
int main(void) {

    NATIONTYPE Head;

    Head = InputNations(NULL);

    LinkAllies(Head);

    PrintAllies(Head);

    FreeNations(&Head);

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
