//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
//-----------------------------------------------------------------------------
#define MAX_ARGUMENTS 20
#define COMMAND_LENGTH 80

typedef char cstring[COMMAND_LENGTH];
//-----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

    FILE *InputFile;
    cstring Command;
    char *MyARGV[MAX_ARGUMENTS];
    int ArgumentIndex,ChildPID,Status;

    if (argc !=2) {
        printf("Usage: %s <filename>\n",argv[0]);
        exit(EXIT_FAILURE);
    }

    if ((InputFile=fopen(argv[1],"r")) == NULL) {
        perror("Opening command file");
        exit(EXIT_FAILURE);
    }

    while (fgets(Command,COMMAND_LENGTH,InputFile) != NULL) {
        Command[strlen(Command)-1] = '\0';
        ArgumentIndex = 0;
        MyARGV[ArgumentIndex] = strtok(Command," ");
        while (MyARGV[ArgumentIndex++] != NULL) {
            if (ArgumentIndex == MAX_ARGUMENTS) {
                printf("ERROR: Too many arguments\n");
                exit(EXIT_FAILURE);
            }
            MyARGV[ArgumentIndex] = strtok(NULL," ");
        }
    
        if ((ChildPID = fork()) == -1) {
            perror("Forking new process");
//----If 0 then in child, exec
        } else if (ChildPID ==  0) {
            execvp(MyARGV[0],MyARGV);
            printf("ERROR: Could not exec %s\n",MyARGV[0]);
            perror("Exec");
            exit(EXIT_FAILURE);
        }
    }

    fclose(InputFile);

    while (wait(&Status) != -1) {
    }

    return(EXIT_SUCCESS);

}
//-----------------------------------------------------------------------------
