//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_STRING 128
#define MAX_GROUP 10

typedef char String[MAX_STRING];

typedef enum {
    australian,
    american,
    irishman,
    error
} NationType;

typedef union {
    int LitersOfBeer;
    float Income;
    char FavouriteLetter;
} NationInfoType;

typedef struct {
    String Name;
    NationType Nationality;
    NationInfoType Information;
} PersonType;

typedef PersonType People[MAX_GROUP];
//-----------------------------------------------------------------------------
NationType InputNationType(void) {

    String Nation;

    scanf("%s",Nation);
    if (!strcmp(Nation,"Australian")) {
        return(australian);
    }
    if (!strcmp(Nation,"American")) {
        return(american);
    }
    if (!strcmp(Nation,"Irishman")) {
        return(irishman);
    }
    return(error);
}
//-----------------------------------------------------------------------------
char* StringNationType(NationType Nation) {

    switch (Nation) {
        case australian:
            return("Australian");
            break;
        case american:
            return("American");
            break;
        case irishman:
            return("Irishman");
            break;
        default:
            return("error");
            break;
    }
}
//-----------------------------------------------------------------------------
PersonType InputPersonType(void) {

    PersonType Person;

    printf("What is his/her name             : ");
    scanf("%s",Person.Name);
    printf("What is his/her nationality      : ");
    Person.Nationality = InputNationType();
    switch (Person.Nationality) {
        case australian:
            printf("How much beer does (s)he drink   : ");
            scanf("%d",&Person.Information.LitersOfBeer);
            break;
        case american:
            printf("How much money does (s)he earn   : ");
            scanf("%f",&Person.Information.Income);
            break;
        case irishman:
            printf("What is his/her favourite letter : ");
            scanf(" %c",&Person.Information.FavouriteLetter);
            break;
        default:
            printf("error");
            break;
    }
    return(Person);
}
//-----------------------------------------------------------------------------
void PrintPersonType(PersonType Person) {

    printf("%s is an %s, and (s)he ",Person.Name,
StringNationType(Person.Nationality));
    switch (Person.Nationality) {
        case australian:
            printf("drinks %d liters of beer",Person.Information.LitersOfBeer);
            break;
        case american:
            printf("earns $%.2f",Person.Information.Income);
            break;
        case irishman:
            printf("who like the letter '%c'",
Person.Information.FavouriteLetter);
            break;
        default:
            printf("error");
            break;
    }
    printf("\n");
}
//-----------------------------------------------------------------------------
int CouldBeFriends(PersonType Person1,PersonType Person2) {

    return(!strcmp(Person1.Name,Person2.Name) ||
Person1.Nationality == Person2.Nationality);

}
//-----------------------------------------------------------------------------
int main(void) {

    People Group;
    int NumberInGroup;
    int Index,FriendIndex;

    printf("How many people in the group : ");
    scanf("%d",&NumberInGroup);
    for (Index = 0; Index < NumberInGroup; Index++) {
        Group[Index] = InputPersonType();
    }
    printf("\n");
    for (Index = 0; Index < NumberInGroup; Index++) {
        PrintPersonType(Group[Index]);
    }
    
    printf("\n");
    for (Index = 0; Index < NumberInGroup; Index++) {
        for (FriendIndex = Index+1; FriendIndex < NumberInGroup; 
FriendIndex++) {
            if (CouldBeFriends(Group[Index],Group[FriendIndex])) {
                printf("%s the %s and %s the %s could be friends\n",
Group[Index].Name,StringNationType(Group[Index].Nationality),
Group[FriendIndex].Name,StringNationType(Group[FriendIndex].Nationality));
            }
        }
    }

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
