#include <stdio.h>
#include <stdlib.h>

#define STINKING_RICH 500000
#define QUITE_RICH 200000
#define MIAMI_POOR 100000
#define AVERAGE 50000
#define REALISTIC 20000

#define HIGH_RATE 0.25
#define MEDIUM_RATE 0.1
#define LOW_RATE 0.03

#define MAX_TAX 50000
//-----------------------------------------------------------------------------
void InputIncomeAndDeductions(double *Income,double *Deductions) {

    double Amount;

    *Income = 0.0;
    *Deductions = 0.0;
//----   1.1 Repeatedly until 0.0 is enetered
    do {
//----       1.1.1 Prompt user
        printf("Enter next Amount : ");
//----       1.1.2 Input value
        scanf("%lf",&Amount);
//----       1.1.3 If positive 
        if (Amount > 0.0) {
//----           1.1.3.1 Add to income
            *Income += Amount;
        } else {
//----       1.1.4 If negative 
//----           1.1.4.1 Add (absolute) to deduction
            *Deductions -= Amount;
        }
    } while (Amount != 0.0);

}
//-----------------------------------------------------------------------------
double ComputeTaxableIncome(double Income,double Deductions) {

//----   2.1 If income >= deduction taxable is income - deduction, else 
    if (Income >= Deductions) {
        return(Income - Deductions);
    } else {
//----   2.2 Taxable is 0.0
        return(0.0);
    }
}
//-----------------------------------------------------------------------------
char ChooseTaxGroup(double Income) {

//----   3.1 If taxable >= 500000
    if (Income >= STINKING_RICH) {
//----       3.1.1 Group is S, else
        return('S');
//----   3.2 If taxable >= 200000
    } else if (Income >= QUITE_RICH) {
//----       3.2.1 Group is Q, else
        return('Q');
//----   3.3 If taxable >= 100000
    } else if (Income >= MIAMI_POOR) {
//----       3.3.1 Group is M, else
        return('M');
//----   3.4 If taxable >= 50000
    } else if (Income >= AVERAGE) {
//----       3.4.1 Group is A, else
        return('A');
//----   3.5 If taxable >= 20000
    } else if (Income >= REALISTIC) {
//----       3.5.1 Group is R, else
        return('R');
    } else {
//----   3.6 Group is P
        return('P');
    }
}
//-----------------------------------------------------------------------------
double ComputeTax(double Taxable,char group) {
    
    double Tax;

//----   4.1 Depending on the group
    switch (group) {
//----       4.1.1 For S and Q
        case 'S':
        case 'Q':
//----           4.1.1.1 Tax is 25% of taxable
            Tax = HIGH_RATE * Taxable;
            break;
//----       4.1.2 For M
        case 'M':
//----           4.1.2.1 Tax is 10% of taxable
            Tax = MEDIUM_RATE * Taxable;
            break;
//----       4.1.3 For A and R
        case 'A':
        case 'R':
//----           4.1.3.1 Tax is 10% of taxable
            Tax = LOW_RATE * Taxable;
            break;
//----       4.1.4 For P
        case 'P':
//----           4.1.4.1 Tax is 0.0
            Tax = 0.0;
            break;
//----       4.1.5 For other groups
        default:
//----           4.1.5.1 Error!
            printf("ERROR: Illegal tax group\n");
            Tax = 0.0;
            break;
    }

//----   4.2 If tax > 50000 then
    if (Tax > MAX_TAX) {
//----       4.2.1 tax = 50000
        Tax = MAX_TAX;
    }

    return(Tax);
}
//-----------------------------------------------------------------------------
void DisplayTaxInformation(double Income,double Deductions,
double TaxableIncome,char TaxGroup,double TaxOwed) {

    printf("\n");
//----   5.1 Display income
    printf("Income         = $%9.2f\n",Income);
//----   5.2 Display deduction
    printf("Deductions     = $%9.2f\n",Deductions);
//----   5.3 Display taxable
    printf("Taxable Income = $%9.2f\n",TaxableIncome);
//----   5.4 Display group
    printf("Tax group      = %c\n",TaxGroup);
//----   5.5 Display tax 
    printf("Tax owed       = $%9.2f\n",TaxOwed);
}
//-----------------------------------------------------------------------------
int main(void) {

    double Income,Deductions;
    double TaxableIncome,TaxOwed;
    char TaxGroup;

//----1. Input income and deduction
    InputIncomeAndDeductions(&Income,&Deductions);

//----2. Compute taxable income
    TaxableIncome = ComputeTaxableIncome(Income,Deductions);
//----3. Compute tax group
    TaxGroup = ChooseTaxGroup(TaxableIncome);
//----4. Compute tax
    TaxOwed = ComputeTax(TaxableIncome,TaxGroup);

//----5. Display tax information
    DisplayTaxInformation(Income,Deductions,TaxableIncome,TaxGroup,
TaxOwed);

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
