//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STRING_LENGTH 1024
#define SENTINEL "."
#define I_AM "I am "
#define OUTPUT_FILE "MyQualities.txt"

typedef char String[STRING_LENGTH+1];
//-----------------------------------------------------------------------------
void ReadAndSaveQualities(String Qualities) {

    FILE * MyQualities;
    String Sentence;
    String Quality;

//----Open file for output
    if ((MyQualities = fopen(OUTPUT_FILE,"w")) == NULL) {
        perror("Could not open output file");
        exit(EXIT_FAILURE);
    }
//----Initialize qualities
    strcpy(Qualities,"");

//----Read sentences until sentinel
    printf("Please enter sentences, . line to end.\n");
    fgets(Sentence,STRING_LENGTH,stdin);
    Sentence[strlen(Sentence)-1] = '\0';
    while (strcmp(Sentence,SENTINEL)) {
//----Check if it starts with "I am"
        if (strstr(Sentence,I_AM) == Sentence) {
//----Extract the quality
            strncpy(Quality,&Sentence[5],STRING_LENGTH);
//----Append to growing string
            strncat(Qualities,Quality,STRING_LENGTH-strlen(Qualities));
            strncat(Qualities,", ",STRING_LENGTH-strlen(Qualities));
//----Append to file
            fputs(&Sentence[5],MyQualities);
            fputc('\n',MyQualities);
        }
//----Get next sentence
        fgets(Sentence,STRING_LENGTH,stdin);
        Sentence[strlen(Sentence)-1] = '\0';
    }
//----Close file
    fclose(MyQualities);

//----Kill the final ", "
    Qualities[strlen(Qualities)-2] = '.';
    Qualities[strlen(Qualities)-1] = '\0';
}
//-----------------------------------------------------------------------------
void ConfirmQualities(void) {

    FILE * MyQualities;
    String Quality;

//----Open file for confirmation
    if ((MyQualities = fopen(OUTPUT_FILE,"r")) == NULL) {
        perror("Could not open output file");
        exit(EXIT_FAILURE);
    }
//----Read and echo the file
    printf("\nConfirming the saved qualities ...\n");
    while (fgets(Quality,STRING_LENGTH,MyQualities) != NULL) {
        printf("    %s",Quality);
    }
//----Close file
    fclose(MyQualities);
}
//-----------------------------------------------------------------------------
int main (int argc, char * argv[]) {

    String Qualities;

//----Read the qualities, and save them to file
    ReadAndSaveQualities(Qualities);
//----Echo the qualities
    printf("The qualities are %s\n",Qualities);
//----Confirm the qualities from file
    ConfirmQualities();
//----Remove the file
    remove(OUTPUT_FILE);

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
