//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_STRING 128

typedef char String[MAX_STRING];

typedef enum {
    mammal,
    insect,
    bird,
    fish,
    error
} AnimalType;

typedef struct {
    String Name;
    float Size;
    AnimalType Type;
} NewSpeciesType;
//-----------------------------------------------------------------------------
void * Malloc(size_t Size) {

    void * Memory;

    if ((Memory = malloc(Size)) == NULL) {
        perror("Cannot malloc");
        exit(EXIT_FAILURE);
    } else {
        return(Memory);
    }
}
//-----------------------------------------------------------------------------
void Free(void ** Memory) {

    free(*Memory);
    *Memory = NULL;
}
//-----------------------------------------------------------------------------
AnimalType InputAnimalType(void) {

    String TheType;

    scanf("%s",TheType);
    if (!strcasecmp(TheType,"mammal")) {
        return(mammal);
    }
    if (!strcasecmp(TheType,"insect")) {
        return(insect);
    }
    if (!strcasecmp(TheType,"bird")) {
        return(bird);
    }
    if (!strcasecmp(TheType,"fish")) {
        return(fish);
    }
    return(error);
}
//-----------------------------------------------------------------------------
char* StringAnimalType(AnimalType TheType) {

    switch (TheType) {
        case mammal:
            return("mammal");
            break;
        case insect:
            return("insect");
            break;
        case bird:
            return("bird");
            break;
        case fish:
            return("fish");
            break;
        default:
            return("error");
            break;
    }
}
//-----------------------------------------------------------------------------
NewSpeciesType InputNewSpecies(void) {

    NewSpeciesType TheAnimal;

    printf("What is the name : ");
    scanf("%s",TheAnimal.Name);
    if (strcmp(TheAnimal.Name,"exit")) {
        printf("What is the size : ");
        scanf("%f",&(TheAnimal.Size));
        printf("What is the type : ");
        TheAnimal.Type = InputAnimalType();
    }

    return(TheAnimal);
}
//-----------------------------------------------------------------------------
void PrintNewSpeciesType(NewSpeciesType TheAnimal) {

    printf("%-20s has size %6.2f and is a %s\n",TheAnimal.Name,TheAnimal.Size,
StringAnimalType(TheAnimal.Type));
}
//-----------------------------------------------------------------------------
int main(void) {

    NewSpeciesType * NewSpecies;
    NewSpeciesType ANewAnimal;
    int NumberOfNewSpecies;
    int SizeOfArray;
    int Index;

    NumberOfNewSpecies = 0;
    NewSpecies = Malloc(sizeof(NewSpeciesType));
    SizeOfArray = 1;

    printf("Enter animal information (\"exit\" to exit)\n");
    ANewAnimal = InputNewSpecies();
    while (strcmp(ANewAnimal.Name,"exit")) {
        if (SizeOfArray == NumberOfNewSpecies) {
            SizeOfArray *= 2;
            NewSpecies = (NewSpeciesType *)realloc(NewSpecies,
SizeOfArray*sizeof(NewSpeciesType));
        }
        NewSpecies[NumberOfNewSpecies++] = ANewAnimal;
        printf("Enter animal information (\"exit\" to exit)\n");
        ANewAnimal = InputNewSpecies();
    }

    printf("The following new species were found:\n");
    for (Index = 0;Index < NumberOfNewSpecies;Index++) {
        PrintNewSpeciesType(NewSpecies[Index]);
    }

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
