//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>

#define NUMBER_OF_ITEMS 5

typedef int DataArrayType[NUMBER_OF_ITEMS];
typedef int * IntPtr;
typedef IntPtr DataPointerArrayType[NUMBER_OF_ITEMS];
//-----------------------------------------------------------------------------
void PrintDataArray(DataArrayType ToPrint) {

    int Index;

    for (Index=0; Index < NUMBER_OF_ITEMS; Index++) {
        printf("%2d : %10d\n",Index,ToPrint[Index]);
    }
}
//-----------------------------------------------------------------------------
void PrintDataPointerArray(DataPointerArrayType ToPrint) {

    int Index;

    for (Index=0; Index < NUMBER_OF_ITEMS; Index++) {
        printf("%2d : %10d\n",Index,*(ToPrint[Index]));
    }
}
//-----------------------------------------------------------------------------
void RandomizeDataArray(DataArrayType ToRandomize,
DataPointerArrayType Pointers) {

    int Index;

    srand(getpid());
    for (Index=0; Index < NUMBER_OF_ITEMS; Index++) {
        ToRandomize[Index] = rand();
        Pointers[Index] = &ToRandomize[Index];
    }
}
//-----------------------------------------------------------------------------
void SortDataPointerArray(DataPointerArrayType ToSort) {

    int Swapped;
    int Index;
    IntPtr Temporary;

    Swapped = 1;
    while (Swapped) {
        Swapped = 0;
        for (Index=0; Index < NUMBER_OF_ITEMS-1; Index++) {
            if (*(ToSort[Index]) > *(ToSort[Index+1])) {
                Temporary = ToSort[Index];
                ToSort[Index] = ToSort[Index+1];
                ToSort[Index+1] = Temporary;
                Swapped = 1;
            }
        }
    }
}
//-----------------------------------------------------------------------------
void SortDataArray(DataArrayType ToSort) {

    int Swapped;
    int Index;
    int Temporary;

    Swapped = 1;
    while (Swapped) {
        Swapped = 0;
        for (Index=0; Index < NUMBER_OF_ITEMS-1; Index++) {
            if (*(ToSort+Index) > *(ToSort+Index+1)) {
                Temporary = *(ToSort+Index);
                *(ToSort+Index) = *(ToSort+Index+1);
                *(ToSort+Index+1) = Temporary;
                Swapped = 1;
            }
        }
    }
}
//-----------------------------------------------------------------------------
int main(void) {

    DataArrayType RandomData;
    DataPointerArrayType DataPointers;

    RandomizeDataArray(RandomData,DataPointers);
    printf("---- Random data ----\n");
    PrintDataArray(RandomData);
    SortDataPointerArray(DataPointers);
    printf("---- Sorted pointers ----\n");
    PrintDataPointerArray(DataPointers);
    SortDataArray(RandomData);
    printf("---- Sorted data ----\n");
    PrintDataArray(RandomData);
    printf("---- Desorted pointers ----\n");
    PrintDataPointerArray(DataPointers);

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
