#include <stdio.h>
#include <stdlib.h>

#define FEET_PER_ATM 33
#define MAX_O2_PRESSURE 1.4
#define CONTINGENCY_O2_PRESSURE 1.6
//-----------------------------------------------------------------------------
int main(void) {

//----Variables to hold input values
    int DepthInFeet;
    int PercentageO2InGas;
    float AmbientPressure,O2Pressure;
    char O2Group;

//----1. Input data 
    printf("Enter depth and percentage O2   : ");
//----   1.1 Input depth
//----   1.2 Input percentage O2
    scanf("%d %d",&DepthInFeet,&PercentageO2InGas);

//----2. Compute dive data
//----   2.1 Compute ambient pressure = (depth / 33) + 1
    AmbientPressure = 1 + (float)DepthInFeet / FEET_PER_ATM;
//----   2.2 Compute PPO2 = ambient * (percentage O2 / 100)
    O2Pressure = (float)PercentageO2InGas/100 * AmbientPressure;
//----   2.3 Compute OPG 
//----       2.3.1 N = integer part of PPO2 * 10
//----       2.3.2 Take Nth letter after 'A'
    O2Group = (char)((int)(O2Pressure * 10)  + (int)'A');

//----3. Display dive data
//----   3.1 Display ambient pressure, PPO2, OPG
    printf("\nAmbient pressure                : %3.1f\n",AmbientPressure);
    printf("O2 pressure                     : %3.1f\n",O2Pressure);
    printf("O2 group                        : %3c\n",O2Group);
//----   3.2 Display excessive O2 pressure
    printf("\n");
    printf("Exceeds maximal O2 pressure     : %s\n",
O2Pressure > MAX_O2_PRESSURE ? "true" : "false");
    printf("Exceeds contingency O2 pressure : %s\n",
O2Pressure > CONTINGENCY_O2_PRESSURE ? "true" : "false");

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
