#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/wait.h>

#define MAX_ALARMS 3
#define ALARM_TIME 5
//-----------------------------------------------------------------------------
void InterruptCatcher(int TheSignal) {

    extern int ChildPID;

    printf("SignalSender just got an interrupt\n");
    alarm(ALARM_TIME);
    if (kill(ChildPID,SIGUSR1) == -1) {
        perror("SignalSender could not send SIGUSR1 to child");
        exit(EXIT_FAILURE);
    }
}
//-----------------------------------------------------------------------------
void AlarmCatcher(int TheSignal) {

    extern int NumberOfAlarms;

    NumberOfAlarms++;
    printf("SignalSender just got alarm %d\n",NumberOfAlarms);
    alarm(ALARM_TIME);
}
//-----------------------------------------------------------------------------
int main(void) {

    extern int NumberOfAlarms;
    extern int ChildPID;
    int Status;

    if (signal(SIGINT,InterruptCatcher) == SIG_ERR) {
        perror("SignalSender could not set SIGINT handler");
        return(EXIT_FAILURE);
    }

    if (signal(SIGALRM,AlarmCatcher) == SIG_ERR) {
        perror("SignalSender could not set SIGALRM handler");
        return(EXIT_FAILURE);
    }

    if ((ChildPID = fork()) == -1) {
        perror("SignalSender could not fork");
        exit(EXIT_FAILURE);
    }

    if (ChildPID == 0) {
        execlp("SignalReceiver.out","SignalReceiver",NULL);
        perror("Error in exec");
        exit(EXIT_FAILURE);
    } else {
        NumberOfAlarms = 0;
        alarm(ALARM_TIME);
        while (NumberOfAlarms < MAX_ALARMS) {
            pause();
        }
    }

    if (kill(ChildPID,SIGKILL) == -1) {
        perror("SignalSender could not send SIGKILL to child");
        exit(EXIT_FAILURE);
    }
    while (wait(&Status) != -1) {
    }

    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
int NumberOfAlarms;
int ChildPID;
//-----------------------------------------------------------------------------
