#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <signal.h>

#define FALSE 0
#define TRUE 1
//-----------------------------------------------------------------------------
void SIGUSR1Handler(int TheSignal) {

    extern int SendFinal0;

    if (TheSignal != SIGUSR1) {
        printf("I: That's weird, I got a signal other than SIGUSR1\n");
    }
    printf("I: Received a SIGUSR1, stopping loop\n");
    SendFinal0 = TRUE;
}
//-----------------------------------------------------------------------------
int main(int argc,char * argv[]) {

    FILE *FIFOWrite;
    int FibonacciNumber;
    extern int SendFinal0;

    if (signal(SIGUSR1,SIGUSR1Handler) == SIG_ERR) {
        perror("Could not install SIGUSR1 handler");
        exit(EXIT_FAILURE);
    }
//----Do not restart interrupted system calls
    if (siginterrupt(SIGUSR1,TRUE) == -1) {
        perror("Abandoning interrupted system calls");
        exit(EXIT_FAILURE);
    }   

    if ((FIFOWrite = fopen(argv[1],"w")) == NULL) {
        perror("Opening FIFO to write");
        exit(EXIT_FAILURE);
    }
    siginterrupt(SIGUSR1,TRUE);

    SendFinal0 = FALSE;
    do {
        printf("I: Which Fibonacci number do you want : ");
        if (scanf(" %d",&FibonacciNumber) != 1) {
            printf("I: Reading from user abandoned\n");
            FibonacciNumber = 0;
        }
        if (SendFinal0) {
            FibonacciNumber = 0;
        }
        fprintf(FIFOWrite,"%d\n",FibonacciNumber);
        fflush(FIFOWrite);
    } while (FibonacciNumber != 0);

    fclose(FIFOWrite);

    printf("I: Interface is exiting\n");
    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
int SendFinal0;
//-----------------------------------------------------------------------------
