/*---------------------------------------------------------------------------*/
/*----A program that displays all comments in a C program */
/*----Written by Geoff Sutcliffe 8 January 2001 */
/*---------------------------------------------------------------------------*/
#include <stdio.h>
/*---------------------------------------------------------------------------*/
/*----Define a boolean data type, with constants */
typedef int boolean;
#define FALSE 0
#define TRUE 1
/*----Define QUOTE by its ASCII number, to avoid confusion with a string */
#define QUOTE 34
/*---------------------------------------------------------------------------*/
int main(void) {

    boolean InComment = FALSE;
    boolean InString = FALSE;
    char PreviousChar;
    int ThisChar;

    printf("These are the comments, starting with /* and ending with */\n");

/*----Loop, reading one character at a time */
    ThisChar = getchar();
    while (ThisChar != EOF) {
/*----If in a comment, then echo the character */
        if (InComment) {
            putchar(ThisChar);
        }
/*----If a " not in a comment, then start or end of a string literal */
        if (!InComment && ThisChar == QUOTE) {
            InString = !InString;
        }
/*----If not in a string literal and have a /, then maybe start or end */
        if (!InString && ThisChar == '/') {
/*----If in a comment and the previous char was a *, then end of comment */
            if (InComment && PreviousChar == '*') {
                InComment = FALSE;
                putchar('\n');
            }
/*----If not in a comment, then look ahead to see if the start of one */
            if (!InComment) {
                PreviousChar = ThisChar;
                ThisChar = getchar();
                if (ThisChar =='*') {
                    InComment = TRUE;
                    putchar(PreviousChar);
                    putchar(ThisChar);
                } 
            }
        }
/*----Get the next character */
        PreviousChar = ThisChar;
        ThisChar = getchar();
    }
            
return(0);
}
/*---------------------------------------------------------------------------*/
