/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#define BOOLEAN int
#define TRUE 1
#define FALSE 0
/*---------------------------------------------------------------------------*/
double *address(double *base,int rows,int columns,int required_row,
int required_column) {

    return(base + (columns*required_row + required_column));

}
/*---------------------------------------------------------------------------*/
double *input_matrix(int *rows,int *columns,char *name) {

    int row,column;
    double *matrix;

    printf("Enter number of rows and columns for %s :",name);
    scanf(" %d %d",rows,columns);
    if ((matrix = malloc(*rows * *columns * sizeof(double))) != NULL) {
        printf("Enter %s in matrix format\n",name);
        for (row=0;row < *rows;row++)
        for (column=0;column < *columns;column++)
            scanf("%lf",address(matrix,*rows,*columns,row,column));
    }

    return(matrix);

}
/*---------------------------------------------------------------------------*/
void output_matrix(double *matrix,int rows,int columns) {

    int row,column;

    for (row=0;row < rows;row++) {
       for (column=0;column < columns;column++)
          printf("%4.0f  ",*address(matrix,rows,columns,row,column));
       printf("\n");
    }
}
/*---------------------------------------------------------------------------*/
BOOLEAN matrix_multiply(double *m1,int m1_rows,int m1_columns,
double *m2,int m2_rows,int m2_columns,double *m3) {

    int row,column,index;

    if (m1_columns != m2_rows)
        return(FALSE);
    else {
        for (row=0;row<m1_rows;row++)
            for (column=0;column<m2_columns;column++) {
                *address(m3,m1_rows,m2_columns,row,column) = 0.0;
                for (index=0;index<m1_columns;index++) {
                    *address(m3,m1_rows,m2_columns,row,column) +=
*address(m1,m1_rows,m1_columns,row,index) *
*address(m2,m2_rows,m2_columns,index,column);
                }
            }
        return(TRUE);
    }
}
/*---------------------------------------------------------------------------*/
int main(void) {

    double *m1,*m2,*m3;
    int m1_rows,m1_columns,m2_rows,m2_columns;

    if (((m1 = input_matrix(&m1_rows,&m1_columns,"Matrix 1")) != NULL) &&
((m2 = input_matrix(&m2_rows,&m2_columns,"Matrix 2")) != NULL) &&
((m3 = malloc(m1_rows*m2_columns*sizeof(double))) != NULL)) {
        printf("Matrix 1\n");
        output_matrix(m1,m1_rows,m1_columns);
        printf("Matrix 2\n");
        output_matrix(m2,m2_rows,m2_columns);
        if (matrix_multiply(m1,m1_rows,m1_columns,m2,m2_rows,m2_columns,m3)) {
            printf("Product\n");
            output_matrix(m3,m1_rows,m2_columns);
            free(m1);
            free(m2);
            free(m3);
            return(0);
        } else {
            printf("Error in dimensions\n");
            free(m1);
            free(m2);
            free(m3);
            return(-1);
        }
    } else {
        free(m1);
        free(m2);
        free(m3);
        printf("Error allocating memory\n");
        return(-2);
    }
}
/*---------------------------------------------------------------------------*/
