/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>

#define MAXIMAL_PEOPLE 10
#define MAXIMAL_STRING_LENGTH 128

/*----Define data types */
typedef char string[MAXIMAL_STRING_LENGTH];
typedef struct personTag {
    string name;
    int age;
    struct personTag *bestFriend;
    } personType;
typedef personType *personPointer;
typedef personPointer peoplePointers[MAXIMAL_PEOPLE];
/*---------------------------------------------------------------------------*/
/*----Find the element in the array whose struct has this name */
personPointer findPerson(peoplePointers people,int numberOfPeople,
string nameToFind) {

    int index = 0;

/*----Index through the array looking at the names */
    while (index < numberOfPeople)
        if (strcmp(people[index]->name,nameToFind) == 0)
            return(people[index]);
        else index++;

    return(NULL);
}
/*---------------------------------------------------------------------------*/
/*----Read the names and ages of the people */
int readPeople(peoplePointers people) {

    int numberOfPeople = 0;
    string nextName;

    do {
        printf("Please enter person name, \"exit\" to exit : ");
        scanf(" %s",nextName);
/*----Check if the sentinel */
        if (strcmp(nextName,"exit") != 0) {
/*----Allocate memory */
            if ((people[numberOfPeople] = 
(personPointer)malloc(sizeof(personType))) == NULL) {
                perror("Allocating a person");
                exit(-1);
            }
/*----Fill name name and age fields */
            strcpy(people[numberOfPeople]->name,nextName);
            printf("Please enter %s's age : ",people[numberOfPeople]->name);
            scanf(" %d",&people[numberOfPeople]->age);
            people[numberOfPeople]->bestFriend = NULL;
            numberOfPeople++;
        } 
    } while (numberOfPeople < MAXIMAL_PEOPLE && strcmp(nextName,"exit") != 0);

    return(numberOfPeople);

}
/*---------------------------------------------------------------------------*/
/*----For each person add a pointer to the struct of their best friend */
void makeFriends(peoplePointers people,int numberOfPeople) {

    int index;
    string bestFriend;

/*----Index through the people */
    for (index=0;index<numberOfPeople;index++) {
/*----Keep asking until a best friend is found */
        while (people[index]->bestFriend == NULL) {
            printf("Who is %s's best friend? ",people[index]->name);
            scanf(" %s",bestFriend);
/*----Error message if riend not found */
            if ((people[index]->bestFriend = 
findPerson(people,numberOfPeople,bestFriend)) == NULL) 
                printf("Cannot find %s\n",bestFriend);
        }
    }

}
/*---------------------------------------------------------------------------*/
/*----Simple write out of people */
void writePeople(peoplePointers people,int numberOfPeople) {

    int index;

    for (index=0;index<numberOfPeople;index++)
        printf("%-20s is %3d, and his/her best fried is %s\n",
people[index]->name,people[index]->age,people[index]->bestFriend->name);

}
/*---------------------------------------------------------------------------*/
/*----Free the malloced memory */
void freePeople(peoplePointers people,int numberOfPeople) {

    int index;

    for (index=0;index<numberOfPeople;index++)
        free(people[index]);

}
/*---------------------------------------------------------------------------*/
int main(void) {

    int numberOfPeople;
    peoplePointers people;

    numberOfPeople = readPeople(people);
    makeFriends(people,numberOfPeople); 
    writePeople(people,numberOfPeople);

    return(0);
}
/*---------------------------------------------------------------------------*/
