/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <regex.h>

#define MAX_STRING 512
typedef char string[MAX_STRING];

#define SENTENCE_DELIMITERS ".!?"
#define WORD_DELIMITERS " "
/*---------------------------------------------------------------------------*/
int main(void) {

    string userInput;
    string regExp;
    char *sentence;
    char *word;
    char *last_sentence;
    char *last_word;
    int sentenceLength;
    regex_t compiledRegExp;

/*----Get the string and reg exp */
    printf("Please enter the string to analyse\n");
    fgets(userInput,MAX_STRING-1,stdin);
    userInput[strlen(userInput)-1] = '\0';
    printf("Please enter the regular expression : ");
    fgets(regExp,MAX_STRING-1,stdin);
    regExp[strlen(regExp)-1] = '\0';

/*----Compile the reg exp */
    if (regcomp(&compiledRegExp,regExp,REG_BASIC) != 0) {
        printf("ERROR: Something wrong in the regular expression\n");
        exit(-1);
    }

/*----Split into sentences */
    sentence = strtok_r(userInput,SENTENCE_DELIMITERS,&last_sentence);
    while (sentence != NULL) {
/*----Skip spaces between sentences */
        while (*sentence == ' ')
            sentence++;
        printf("%s\n",sentence);
/*----Check for regexp */
        if (regexec(&compiledRegExp,sentence,0,NULL,0) == 0)
            printf("Yes   ");
        else printf("No    ");
/*----Split into words */
        word = strtok_r(sentence,WORD_DELIMITERS,&last_word);
        sentenceLength = 0;
        while (word != NULL) {
            sentenceLength++;
            word = strtok_r(NULL,WORD_DELIMITERS,&last_word);
        }
        printf("%d words\n",sentenceLength);
        sentence = strtok_r(NULL,SENTENCE_DELIMITERS,&last_sentence);
    }

    return(0);
}
/*---------------------------------------------------------------------------*/
