/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <unistd.h>

#define STDIN 0
#define STDOUT 1
#define STRING_LENGTH 256
/*---------------------------------------------------------------------------*/
int main(int argc,char *argv[]) {

    int DownPipe[2],UpPipe[2];
    char Buffer[STRING_LENGTH];
    int NumberRead;

/*----Create pipes */
    if (pipe(DownPipe) == -1) {
        perror("Creating down pipe");
        exit(-1);
    }
    if (pipe(UpPipe) == -1) {
        perror("Creating up pipe");
        exit(-1);
    }
/*----Fork child */
    if (fork() == 0) {
/*----Child takes stdin from one pipe */
        close(DownPipe[1]);
        if (dup2(DownPipe[0],STDIN) == -1) {
            perror("dup STDIN");
            exit(-1);
        }
/*----Child sends stdout to other pipe */
        close(UpPipe[0]);
        if (dup2(UpPipe[1],STDOUT) == -1) {
            perror("dup STDOUT");
            exit(-1);
        }
/*----Child reads and bounces */
        while (fgets(Buffer,STRING_LENGTH,stdin) != NULL) {
            printf("Bounced %s",Buffer);
            fflush(stdout);
        }
        close(DownPipe[0]);
        close(UpPipe[1]);
    } else {
/*----Parent close child's ends of pipes */
        close(DownPipe[0]);
        close(UpPipe[1]);
/*----Parent writes user input down pipe */
        printf("Enter lines to send down for bounce\n");
        while (fgets(Buffer,STRING_LENGTH,stdin) != NULL) {
            if (write(DownPipe[1],Buffer,strlen(Buffer)) != strlen(Buffer)) {
                perror("Writing down pipe");
                exit(-1);
            }
/*----Parent reads bounce from child off other pipe */
            if ((NumberRead = read(UpPipe[0],Buffer,STRING_LENGTH)) <= 0) {
                perror("Reading up pipe");
                exit(-1);
            }
            Buffer[NumberRead]  = '\0';
            printf("%s",Buffer);
        }
        close(DownPipe[1]);
        close(UpPipe[0]);
    }

    return(0);

}
/*---------------------------------------------------------------------------*/
