/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

typedef struct {
    long message_type;
    int data;
    } BufferType;

#define QUEUE_KEY 1000
#define MAX_DATA 10
#define PING_TYPE 1L
#define PONG_TYPE 2L
/*---------------------------------------------------------------------------*/
int main(void) {

    int Index,QueueID;
    BufferType Buffer;

    QueueID = msgget((key_t) QUEUE_KEY,0666|IPC_CREAT);
    printf("Pinging on queue %d\n",QueueID);

    Index = 0;
    while (Index < MAX_DATA) {
        Buffer.message_type = PING_TYPE;
        Buffer.data = Index;
        if (msgsnd(QueueID,&Buffer,sizeof(int),0) == -1) {
            perror("Sending ping");
            exit(-1);
        }
        printf("Sent ping     %d\n",Index);
        if (msgrcv(QueueID,&Buffer,sizeof(int),PONG_TYPE,0) == -1) {
            perror("Receiving pong");
            exit(-1);
        }
        printf("Received pong %d\n",Buffer.data);
        Index = Buffer.data;
    }
    msgctl(QueueID,IPC_RMID,NULL);

    return(0);
}
/*---------------------------------------------------------------------------*/

