/*---------------------------------------------------------------------------*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

typedef struct {
    long message_type;
    int data;
    } BufferType;

#define QUEUE_KEY 1000
#define PING_TYPE 1L
#define PONG_TYPE 2L
/*---------------------------------------------------------------------------*/
int main(void) {

    int Status,QueueID;
    BufferType Buffer;

    QueueID = msgget((key_t) QUEUE_KEY,0);
    printf("Receiving on %d\n",QueueID);

    do {
        if ((Status = msgrcv(QueueID,&Buffer,sizeof(int),PING_TYPE,0)) != -1) {
            printf("Received ping %d\n",Buffer.data);
            sleep(1);
            Buffer.message_type = PONG_TYPE;
            Buffer.data++;
            if (msgsnd(QueueID,&Buffer,sizeof(int),0) == -1) {
                perror("Sending pong");
                exit(-1);
            }
            printf("Sent pong     %d\n",Buffer.data);
        }
    } while (Status != -1);

    return(0);
}
/*---------------------------------------------------------------------------*/
