//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>

#define ARRAY_SIZE 10

#define STACK_SIZE 1000  
#define DATA_TYPE int
static DATA_TYPE Stack[STACK_SIZE];     //----Memory for heap
static DATA_TYPE *TopOfStack = Stack;    //----Toh pointer
//-----------------------------------------------------------------------------
//----Returns a pointer to a stack frame of size
DATA_TYPE *NewStackFrame(int Size) {

//----Check if it fits
    if (TopOfStack + Size <= Stack + STACK_SIZE) {
        TopOfStack += Size;
        return(TopOfStack-Size);
    } else {
        return(NULL);
    }
}
//-----------------------------------------------------------------------------
void DisposeHeapFrame(DATA_TYPE *Frame) {

    if (Frame >= Stack && Frame < TopOfStack) {
        TopOfStack = Frame;
    }
}
//-----------------------------------------------------------------------------
int main(void) {

    DATA_TYPE * MyFibonaccis;
    DATA_TYPE * MySecondArray;
    int Index;

    MyFibonaccis = NewStackFrame(ARRAY_SIZE);
    MyFibonaccis[0] = 0;
    MyFibonaccis[1] = 1;
    for (Index = 2; Index < ARRAY_SIZE; Index++) {
        MyFibonaccis[Index] = MyFibonaccis[Index-1] + MyFibonaccis[Index-2];
    }
    
    for (Index = 0; Index < ARRAY_SIZE; Index++) {
        printf("Direct Fibonacci number %d is %d\n",Index,MyFibonaccis[Index]);
    }
    
    MySecondArray = NewStackFrame(ARRAY_SIZE / 2);
    for (Index = 0; Index < ARRAY_SIZE / 2; Index++) {
        MySecondArray[Index] = MyFibonaccis[Index * 2];
        printf("Alternate Fibonacci number %d is %d\n",Index,
MySecondArray[Index]);
    }
    
    DisposeHeapFrame(MySecondArray);
    for (Index = 0; Index < ARRAY_SIZE; Index++) {
        printf("Direct Fibonacci number %d is %d\n",Index,MyFibonaccis[Index]);
    }
    DisposeHeapFrame(MyFibonaccis);
    
    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
