//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
//-----------------------------------------------------------------------------
typedef struct LinkedNodeTag {
    int SomeData;
    struct LinkedNodeTag *NextNode;
} LinkedNode;

typedef LinkedNode *LinkedNodePointer;

#define SENTINEL -1
//-----------------------------------------------------------------------------
void * Malloc(size_t Size) {

    void * Memory;

    if ((Memory = malloc(Size)) == NULL) {
        perror("Cannot malloc");
        exit(EXIT_FAILURE);
    } else {
        return(Memory);
    }
}
//-----------------------------------------------------------------------------
void Free(void ** Memory) {

    free(*Memory);
    *Memory = NULL;
}
//-----------------------------------------------------------------------------
int main(void) {

    LinkedNodePointer Head = NULL;
    LinkedNodePointer NewNode;
    int UserInput;

    printf("Please enter an integer, %d to end : ",SENTINEL);
    scanf(" %d",&UserInput);
    while (UserInput != SENTINEL) {
        NewNode = (LinkedNodePointer)Malloc(sizeof(LinkedNode));
        NewNode->SomeData = UserInput;
        NewNode->NextNode = Head;
        Head = NewNode;
        printf("Please enter an integer, %d to end : ",SENTINEL);
        scanf(" %d",&UserInput);
    }

    printf("\nThe numbers are ");
    while (Head != NULL) {
        printf("%d ",Head->SomeData);
        NewNode = Head;
        Head = Head->NextNode;
        Free((void **)&NewNode);
    }

    printf("\n");
    
    return(EXIT_SUCCESS);
}
//-----------------------------------------------------------------------------
