//----------------------------------------------------------------------------
//----A decent library of string functions for NameAge programs
//----------------------------------------------------------------------------
#include <iostream.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "mystrclass.h"
//----------------------------------------------------------------------------
//----Default constructor
string::string(void) {

TheCString[0] = '\0';
}
//----------------------------------------------------------------------------
//----Initial value constructor
string::string(const cstring ACString) {

strcpy(TheCString,ACString);
}
//----------------------------------------------------------------------------
//----Check if a string is an integer
boolean string::IsInteger(void) {

boolean NoBadDigits = TRUE;
int StringIndex,
    StringLength;

StringIndex = 0;
StringLength = strlen(TheCString);

while (NoBadDigits && (StringIndex < StringLength))
    if (! isdigit(TheCString[StringIndex]))
        NoBadDigits = FALSE;
    else ++StringIndex;

return(NoBadDigits);
}
//----------------------------------------------------------------------------
//----Convert a string to an integer
int string::ToInteger(void) {

return(atoi(TheCString));
}
//----------------------------------------------------------------------------
//----Reads a string and returns TRUE if successful
boolean string::ReadString(void) {

//----Current reads and is always successful
cin >> TheCString;

return(TRUE);
}
//----------------------------------------------------------------------------
//----Concatenate two strings if not too long
boolean string::Concatenate(string AString2) {

if (strlen(TheCString) + strlen(AString2.TheCString) < MAX_STRING_SIZE) {
    strcat(TheCString,AString2.TheCString);
    return(TRUE);
    }
else return(FALSE);
}
//----------------------------------------------------------------------------
//----Checks if first string is lexicographically greater than the second
boolean string::StringGreater(string AString2) {

return(strcmp(TheCString,AString2.TheCString) > 0);
}
//----------------------------------------------------------------------------
//----Checks if first string is the same as the second
boolean string::StringEqual(string AString2) {

return(strcmp(TheCString,AString2.TheCString) == 0);
}
//----------------------------------------------------------------------------
//----Checks if first string is lexicographically smaller than the second
boolean string::StringSmaller(string AString2) {

return(strcmp(TheCString,AString2.TheCString) < 0);
}
//----------------------------------------------------------------------------
istream& operator >> (istream& InputStream,string& AString) {

InputStream >> AString.TheCString;

return(InputStream);
}
//----------------------------------------------------------------------------
ostream& operator << (ostream& OutputStream,const string& AString) {

OutputStream << AString.TheCString;

return(OutputStream);
}
//----------------------------------------------------------------------------
//----Assignment operator for constants
string& string::operator = (const cstring AString) {

strcpy(TheCString,AString);

return(*this);
}

//----Assignment operator for instances
string& string::operator = (const string& AString) {

strcpy(TheCString,AString.TheCString);

return(*this);
}
//----------------------------------------------------------------------------
