//----------------------------------------------------------------------------
//----A decent library of string functions for NameAge programs
//----------------------------------------------------------------------------
#ifndef MYSTRCLASS_H
#define MYSTRCLASS_H
//----------------------------------------------------------------------------
#include "boolean.h"
#include <iostream.h>

//----Define string data type
const int MAX_STRING_SIZE = 80;
typedef char cstring[MAX_STRING_SIZE];
//----------------------------------------------------------------------------
class string {

public:

//----Default constructor
string(void);

//----Initial value constructor
string(const cstring ACString);

//----Check if a string is an integer
boolean IsInteger(void);

//----Convert a string to an integer
int ToInteger(void);

//----Reads a string and returns TRUE if successful
boolean ReadString(void);

//----Concatenate two strings if not too long
boolean Concatenate(string AString2);

//----Checks if first string is lexicographically greater than the second
boolean StringGreater(string AString2);

//----Checks if first string is the same as the second
boolean StringEqual(string AString2);

//----Checks if first string is lexicographically smaller than the second
boolean StringSmaller(string AString2);

//----Input and output operators. Magic stuff for CP1300
friend istream& operator >> (istream& InputStream,string& AString);
friend ostream& operator << (ostream& OutputStream,const string& AString);

//----Assignment operator. Magic stuff for CP1300
string& operator = (const cstring AString);
string& operator = (const string& AString);

private:

//----The local data
cstring TheCString;

};
//----------------------------------------------------------------------------
#endif
//----------------------------------------------------------------------------
