//-----------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>
#include <math.h>
#include <assert.h>

#define SLEEP_TARGET 30
#define MAX_THREADS 50
#define SHOOT_RATIO 4
//-----------------------------------------------------------------------------
void *IndependentLoop(void *Index) {

    int AccumulatedSleep,TargetIndex,BulletIndex,NumberOfBullets;
    int MyIndex;
    extern int NumberOfThreads;
    extern pthread_t ThreadVector[];
    extern int SleepLengths[];

//----Find self in arrays
    MyIndex = *((int *)Index);

//----Initialize thread
    NumberOfBullets = SleepLengths[MyIndex]/SHOOT_RATIO;
    printf("Thread %2d (%2d) starts, gets %d bullets each round\n",MyIndex,
SleepLengths[MyIndex],NumberOfBullets);
    srand(clock());

//----Thread must loop until is has accumulated enough sleep
    AccumulatedSleep = 0;
    while (AccumulatedSleep < SLEEP_TARGET) {
        printf("Thread %2d (%2d) goes to sleep\n",MyIndex,
SleepLengths[MyIndex]);
        sleep(SleepLengths[MyIndex]);
        AccumulatedSleep += SleepLengths[MyIndex];
        printf("Thread %2d (%2d) has accumulated %2d/%d\n",MyIndex,
SleepLengths[MyIndex],AccumulatedSleep,SLEEP_TARGET);
//----Give thread bullets proportional to sleep length
        printf("Thread %2d (%2d) gets %2d bullets\n",MyIndex,
SleepLengths[MyIndex],NumberOfBullets);
//----Fire at other threads
        for (BulletIndex = 0; BulletIndex < NumberOfBullets; BulletIndex++) {
            TargetIndex = rand() % NumberOfThreads;
            printf("Thread %2d (%2d) fires bullet %2d at thread %2d (%2d)",
MyIndex,SleepLengths[MyIndex],BulletIndex+1,TargetIndex,
SleepLengths[TargetIndex]);
//----Shoot at a thread known to be dead
            if (SleepLengths[TargetIndex] == 0) {
                printf(" and wastes a bullet\n");
//----Suicide is painless (according to MASH)
            } else if (TargetIndex == MyIndex) {
                printf(" and commits suicide!\n");
                SleepLengths[TargetIndex] = 0;
                pthread_exit(NULL);
            } else {
//----If the thread is alive, then the bullet is not wasted.
                printf(" and kills it!\n");
                SleepLengths[TargetIndex] = 0;
                if (pthread_cancel(ThreadVector[TargetIndex]) != 0) {
                    printf("ERROR: Could not cancel thread %2d (%2d) ",
TargetIndex,SleepLengths[TargetIndex]);
                    perror(":");
                    exit(EXIT_FAILURE);
                }
            }
        }
    }

    printf("LIFE! Thread %2d (%2d) has completed\n",MyIndex,
SleepLengths[MyIndex]);
    return(NULL);
}
//-----------------------------------------------------------------------------
int main(int argc,char *argv[]) {

    extern int NumberOfThreads;
    extern pthread_t ThreadVector[];
    extern int SleepLengths[];
    int Index;
    int StableIndices[MAX_THREADS];

    for (Index = 0;Index < MAX_THREADS;Index++) {
        SleepLengths[Index] = 0;
    }
    srand(time(NULL));

    NumberOfThreads = 0;
    for (NumberOfThreads = 0; NumberOfThreads < argc-1; NumberOfThreads++) {
//----Store thread information
        SleepLengths[NumberOfThreads] = atoi(argv[NumberOfThreads+1]);
        StableIndices[NumberOfThreads] = NumberOfThreads;
        if (pthread_create(&ThreadVector[NumberOfThreads],NULL,IndependentLoop,
&StableIndices[NumberOfThreads]) != 0) {
           perror("Creating thread");
           exit(EXIT_FAILURE);
        }
        printf("Started thread %2d (%2d)\n",NumberOfThreads,
SleepLengths[NumberOfThreads]);

//-----Detatch thread
        if (pthread_detach(ThreadVector[NumberOfThreads]) != 0) {
           perror("Detaching thread");
           exit(EXIT_FAILURE);
        }
    }

    printf("Exiting the main program, leaving the threads running\n");
    pthread_exit(NULL);
}
//-----------------------------------------------------------------------------
pthread_t ThreadVector[MAX_THREADS];
int SleepLengths[MAX_THREADS];
int NumberOfThreads;
//-----------------------------------------------------------------------------
